﻿
Imports be.business.connector.recipe.executor
Imports be.business.connector.common
Imports be.business.connector.core.utils
Imports be.business.connector.recipe.executor.domain
Imports be.business.connector.session
Imports System.Text

Public Class ExecutorTool

    Dim moduleRecipeInstance
    Dim initRecipeModule = False
    Dim systemInitialized = False
    Dim listOpenPrescriptionsListPageNumber As Integer = 0
    Dim listReservationsListPageNumber As Integer = 0
    Dim ListRidsHistoryPageNumber As Integer = 0
    Dim listRidsInProcessPageNumber As Integer = 0

    Dim ListOpenPrescriptionsResult As be.recipe.services.executor.ListOpenPrescriptionsResult
    Dim ListReservationsResult As be.recipe.services.executor.ListReservationsResult
    Dim ListRelationsResult As be.recipe.services.executor.ListRelationsResult

    Function GetRecipeModule() As ExecutorIntegrationModuleV4
        InitSystem()
        GetRecipeModule = New ExecutorIntegrationModuleV4Impl()
    End Function

    Function createNewSession(ByVal sessionType As SessionType, ByVal inss As String, ByVal password As String) As String
        Dim sessionItem As be.ehealth.technicalconnector.session.SessionItem
        Dim resultSession As String
        InitSystem()
        If InStr(Command$, "-mock=true") Then
            resultSession = "Create session not supported for mock"
        Else
	        be.ehealth.technicalconnector.beid.BeIDFactory.setInstantiator(New be.fgov.ehealth.technicalconnector.beid.BeIdNetInstantiator())
            sessionItem = be.business.connector.session.SessionUtil.createSession(sessionType, PropertyHandler.getInstance().getPropertiesCopy, inss, password)
            resultSession = SAML10Converter.toXMLString(sessionItem.getSAMLToken.getAssertion)
        End If
        createNewSession = resultSession
    End Function


    Private Sub InitSystem()
        If systemInitialized = False Then
            java.lang.System.setProperty("os.name", "Windows 8")
            Me.ListOpenPrescriptionsPageNumberLabel.Text = "Page: " & listOpenPrescriptionsListPageNumber
            Me.ListReservationsPageNumberLabel.Text = "Page: " & listReservationsListPageNumber
            Me.ListRidsHistoryMonthLabel.Text = "Page: " & ListRidsHistoryPageNumber
            Me.ListRidsInProcessPageNumberLabel.Text = "Page: " & listRidsInProcessPageNumber
            initComboboxes()

            If InStr(Command$, "-mock=true") Then
                ApplicationConfig.getInstance().initialize()
                systemInitialized = True
            Else
                Dim config As String = Nothing
                Dim configValidation As String = Nothing
                Dim foundConfig As Boolean = False
                Dim foundValidationConfig As Boolean = False
                For Each argument In Command$().Split(" ")
                    If InStr(argument, "-config=") Then
                        foundConfig = True
                        config = argument.ToString.Substring(8)
                        Debug.Print("Config file used  " & config)
                    End If
                    If InStr(argument, "-configValidation=") Then
                        foundValidationConfig = True
                        configValidation = argument.ToString.Substring(18)
                        Debug.Print("Config file used  " & configValidation)
                    End If
                    If foundConfig And foundValidationConfig Then
                        Exit For
                    End If
                Next
                If Not String.IsNullOrEmpty(config) And Not String.IsNullOrEmpty(configValidation) Then
                    ApplicationConfig.getInstance().initialize(config, configValidation)

                    Dim defaultInss As String = PropertyHandler.getInstance().getProperty("user.inss")
                    If String.IsNullOrEmpty(defaultInss) Then
                        defaultInss = "84071230581"
                    End If

                    Me.ListOpenPrescriptionsPatientIdTextBox.Text = defaultInss
                    Me.ListRidsHistoryTextBox.Text = defaultInss
                    Me.MandateHolderIdTextBox.Text = defaultInss

                    systemInitialized = True
                    Exit Sub
                End If
            End If
        End If
    End Sub

    Private Sub initComboboxes()
        Me.GetPrescriptionMandateHolderTypeComboBox.Items.AddRange([Enum].GetNames(GetType(be.recipe.services.core.MandateHolderType.__Enum)))
        Me.CreateFeedbackMandateHolderTypeComboBox.Items.AddRange([Enum].GetNames(GetType(be.recipe.services.core.MandateHolderType.__Enum)))
        Me.ListNotificationMandateHolderTypeComboBox.Items.AddRange([Enum].GetNames(GetType(be.recipe.services.core.MandateHolderType.__Enum)))
        Me.ListOpenPrescriptionsMandateHolderTypeComboBox.Items.AddRange([Enum].GetNames(GetType(be.recipe.services.core.MandateHolderType.__Enum)))
        Me.ListRidsInProcessMandateHolderTypeComboBox.Items.AddRange([Enum].GetNames(GetType(be.recipe.services.core.MandateHolderType.__Enum)))
        Me.ListRidsHisotryMandateHolderTypeComboBox.Items.AddRange([Enum].GetNames(GetType(be.recipe.services.core.MandateHolderType.__Enum)))
        Me.ReservationsMandateHolderTypeComboBox.Items.AddRange([Enum].GetNames(GetType(be.recipe.services.core.MandateHolderType.__Enum)))
        Me.ListOpenPrescriptionsBreakTheGlassComboBox.Items.AddRange([Enum].GetNames(GetType(be.recipe.services.executor.ReasonBreakTheGlass.__Enum)))
        Me.ListRidsHistoryBreakTheGlassComboBox.Items.AddRange([Enum].GetNames(GetType(be.recipe.services.executor.ReasonBreakTheGlass.__Enum)))
    End Sub

    Private Sub showError(ByVal p1 As ErrObject)
        If TypeOf p1.GetException Is be.business.connector.core.exceptions.IntegrationModuleValidationException Then
            Dim validationErrorsString As String = ""
            Dim err As be.business.connector.core.exceptions.IntegrationModuleValidationException = TryCast(p1.GetException, be.business.connector.core.exceptions.IntegrationModuleValidationException)
            If err.getValidationErrors IsNot Nothing Then
                For i = 0 To err.getValidationErrors.size - 1
                    Dim item = err.getValidationErrors.get(i)
                    validationErrorsString &= item & vbCrLf
                Next
            End If
            MessageBox.Show(validationErrorsString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        ElseIf TypeOf p1.GetException Is be.business.connector.core.exceptions.IntegrationModuleException Then
            Dim errorsString As String = ""
            Dim err As be.business.connector.core.exceptions.IntegrationModuleException = TryCast(p1.GetException, be.business.connector.core.exceptions.IntegrationModuleException)
            If err.getMessages IsNot Nothing Then
                For i = 0 To err.getMessages.size - 1
                    Dim localString As be.recipe.services.core.LocalisedString = err.getMessages.get(i)
                    If localString.getLang().toString = "EN" Then
                        errorsString &= localString.getValue() & vbCrLf
                    End If
                Next
            End If
            If err.getMessage IsNot Nothing And err.getMessages IsNot Nothing And err.getMessages.size = 0 Then
                errorsString &= "Error: " & err.getMessage & vbCrLf
            End If
            If err.getMessageCode IsNot Nothing Then
                errorsString &= "ErrorCode: " & err.getMessageCode & vbCrLf
            End If
            If err.getPrescriptionStatus IsNot Nothing Then
                errorsString &= "PrescriptionStatus: " & err.getPrescriptionStatus.toString & vbCrLf
            End If
            If err.getStatusUpdater IsNot Nothing Then
                errorsString &= "StatusUpdater: " & err.getStatusUpdater & vbCrLf
            End If
            MessageBox.Show(errorsString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Else
            If Not String.IsNullOrEmpty(p1.Description) Then
                MessageBox.Show(p1.Description, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            End If
        End If
    End Sub



    Private Sub MarkAsDeliveredButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MarkAsDeliveredButton.Click
        On Error GoTo ERR

        MarkAsDeliveredButton.Enabled = False

        GetRecipeModule().markAsDelivered(GetPrescriptionRID.Text, GetPrescriptionMandateHolderIdTextBox.Text, translateMandateHolderType(GetPrescriptionMandateHolderTypeComboBox.Text))

        MessageBox.Show("Prescription successfully marked as delivered!", "Information", MessageBoxButtons.OK, MessageBoxIcon.Information)

        MarkAsDeliveredButton.Enabled = True
        Exit Sub
ERR:
        showError(Err)
        MarkAsDeliveredButton.Enabled = True
    End Sub

    Private Sub MarkAsUndeliveredButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MarkAsUndeliveredButton.Click
        On Error GoTo ERR

        MarkAsUndeliveredButton.Enabled = False

        GetRecipeModule().markAsUndelivered(GetPrescriptionRID.Text, GetPrescriptionMandateHolderIdTextBox.Text, translateMandateHolderType(GetPrescriptionMandateHolderTypeComboBox.Text))

        MessageBox.Show("Prescription successfully marked as undelivered!", "Information", MessageBoxButtons.OK, MessageBoxIcon.Information)

        MarkAsUndeliveredButton.Enabled = True
        Exit Sub
ERR:
        showError(Err)
        MarkAsUndeliveredButton.Enabled = True
    End Sub

    Private Sub MarkAsArchivedButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MarkAsArchivedButton.Click
        On Error GoTo ERR

        MarkAsArchivedButton.Enabled = False

        GetRecipeModule().markAsArchived(GetPrescriptionRID.Text, GetPrescriptionMandateHolderIdTextBox.Text, translateMandateHolderType(GetPrescriptionMandateHolderTypeComboBox.Text))

        MessageBox.Show("Prescription successfully marked as archived!", "Information", MessageBoxButtons.OK, MessageBoxIcon.Information)

        MarkAsArchivedButton.Enabled = True
        Exit Sub
ERR:
        showError(Err)
        MarkAsArchivedButton.Enabled = True
    End Sub
    Private Sub RevokeButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RevokeButton.Click
        On Error GoTo ERR

        RevokeButton.Enabled = False

        GetRecipeModule().revokePrescription(GetPrescriptionRID.Text, InputBox("Revoke Reason:"), GetPrescriptionMandateHolderIdTextBox.Text, translateMandateHolderType(GetPrescriptionMandateHolderTypeComboBox.Text))

        MessageBox.Show("Prescription " & GetPrescriptionRID.Text & " successfully revoked!", "Information", MessageBoxButtons.OK, MessageBoxIcon.Information)

        RevokeButton.Enabled = True
        Exit Sub
ERR:
        showError(Err)
        RevokeButton.Enabled = True
    End Sub
    Private Sub CreateFeedbackBtn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CreateFeedbackBtn.Click
        On Error GoTo ERR

        CreateFeedbackBtn.Enabled = False

        Dim feedback As Byte()
        Dim encoding As New System.Text.UTF8Encoding()
        feedback = encoding.GetBytes(CreateFeedbackContent.Text)


        GetRecipeModule().createFeedback(Long.Parse(CreateFeedbackPrescriber.Text),
                                                 CreateFeedbackRID.Text,
                                                 feedback, CreateFeedbackMandateHolderIdTextBox.Text, translateMandateHolderType(CreateFeedbackMandateHolderTypeComboBox.Text))

        MessageBox.Show("Feedback created!", "Information", MessageBoxButtons.OK, MessageBoxIcon.Information)

        CreateFeedbackBtn.Enabled = True
        Exit Sub
ERR:
        showError(Err)
        CreateFeedbackBtn.Enabled = True
    End Sub

    Private Sub ListNotificationsButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ListNotificationsButton.Click
        On Error GoTo ERR

        ListNotificationsButton.Enabled = False

        Dim i As Integer
        Dim notifications As java.util.List
        Dim item As ListNotificationsItem

        notifications = GetRecipeModule().listNotifications(Not (ListNotificationsUnreadCheckBox.Checked), ListNotificationMandateHolderIdTextBox.Text, translateMandateHolderType(ListNotificationMandateHolderTypeComboBox.Text))

        ListNotificationsResult.Text = ""
        If notifications IsNot Nothing Then
            For i = 0 To notifications.size - 1
                item = notifications.get(i)
                ListNotificationsResult.Text &= "=================================================" & vbCrLf
                ListNotificationsResult.Text &= "Sent by : " + item.getSentBy.ToString & vbCrLf
                If item.getSentDate IsNot Nothing Then
                    ListNotificationsResult.Text &= "Sent date : " + New java.text.SimpleDateFormat("yyyy-MM-dd").format(item.getSentDate) & vbCrLf
                End If
                ListNotificationsResult.Text &= "-------------------------------------------------" & vbCrLf
                ListNotificationsResult.Text &= IOUtils.strConvert(item.getContent) & vbCrLf
                ListNotificationsResult.Text &= "-------------------------------------------------" & vbCrLf
            Next
        End If
        ListNotificationsButton.Enabled = True
        Exit Sub
ERR:
        showError(Err)
        ListNotificationsButton.Enabled = True
    End Sub
    Private Sub btnCreateSession_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCreateSession.Click
        On Error GoTo ERR

        btnCreateSession.Enabled = False
        txtSamlToken.Text = createNewSession(SessionType.EID_SESSION, Nothing, Nothing)
        btnCreateSession.Enabled = True
        Exit Sub
ERR:
        showError(Err)
        btnCreateSession.Enabled = True
    End Sub

    Private Sub btnFallbackSession_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFallbackSession.Click
        On Error GoTo ERR

        btnFallbackSession.Enabled = False

        Dim defaultInss As String = PropertyHandler.getInstance().getProperty("user.inss")
        If String.IsNullOrEmpty(defaultInss) Then
            defaultInss = "84071230581"
        End If

        Dim prompt As PasswordPrompt = New PasswordPrompt()
        prompt.niss.Text = defaultInss

        If prompt.ShowDialog() = DialogResult.OK Then
            txtSamlToken.Text = createNewSession(SessionType.FALLBACK_SESSION, prompt.niss.Text, prompt.password.Text)
        End If
        btnFallbackSession.Enabled = True

        Exit Sub
ERR:
        showError(Err)
        btnFallbackSession.Enabled = True
    End Sub




    Private Sub GetPrescriptionButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GetPrescriptionButton.Click
        On Error GoTo ERR

        GetPrescriptionButton.Enabled = False
        GetprescriptionContent.Clear()
        GetPrescriptionPrescriber.Clear()
        GetPrescriptionPatient.Clear()
        GetprescriptionContent.Clear()
        ExpirationDateTextBox.Clear()
        VisionTextBox.Clear()

        Dim p As GetPrescriptionForExecutorResult

        p = GetRecipeModule().getPrescription(GetPrescriptionRID.Text, GetPrescriptionMandateHolderIdTextBox.Text, translateMandateHolderType(GetPrescriptionMandateHolderTypeComboBox.Text))

        GetPrescriptionDate.Text = p.getCreationDate().getTime.toString
        GetPrescriptionPrescriber.Text = p.getPrescriberId()
        GetPrescriptionPatient.Text = p.getPatientId()
        GetprescriptionContent.Text = IOUtils.strConvert(p.getPrescription())
        Dim pattern = "yyyy-MM-dd"
        Dim simpleDateFormat As java.text.SimpleDateFormat = New java.text.SimpleDateFormat(pattern)
        Dim expirationDateString As String = ""
        If p.getExpirationDate IsNot Nothing Then
            expirationDateString = simpleDateFormat.format(p.getExpirationDate.getTime)
            ExpirationDateTextBox.Text = expirationDateString
        End If
        VisionTextBox.Text = p.getVision()
        If (IsDBNull(p.getInsurabilityResponse())) Then
            MessageBox.Show("No Insurability!", "Information", MessageBoxButtons.OK, MessageBoxIcon.Information)
        Else
            txtInsurabilityOrchestration.Text = p.getInsurabilityResponse()
        End If
        feedbackCheckbox.Checked = p.isFeedbackAllowed().booleanValue

        CreateFeedbackRID.Text = GetPrescriptionRID.Text
        CreateFeedbackPrescriber.Text = p.getPrescriberId().ToString

        GetPrescriptionButton.Enabled = True

        Exit Sub
ERR:
        showError(Err)
        GetPrescriptionButton.Enabled = True
    End Sub

    Private Sub ExecutorTool_Activated(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Activated
        On Error GoTo ERR
        GetRecipeModule()
        Exit Sub
ERR:
        showError(Err)
    End Sub

    Private Sub GetOpenPrescriptionsListButton_Click(sender As Object, e As EventArgs) Handles GetOpenPrescriptionsListButton.Click
        On Error GoTo ERR
        DisableGetOpenPrescriptionsListButtons()
        GetOpenPrescriptionsList()
        EnableGetOpenPrescriptionsListButtons()
        Exit Sub
ERR:
        showError(Err)
        EnableGetOpenPrescriptionsListButtons()
    End Sub

    Private Sub EnableGetOpenPrescriptionsListButtons()
        GetOpenPrescriptionsListButton.Enabled = True
        PutInProcessButton.Enabled = True
        If listOpenPrescriptionsListPageNumber = 0 Then
            NextPageButton.Enabled = False
        Else
            NextPageButton.Enabled = True
        End If
    End Sub

    Private Sub DisableGetOpenPrescriptionsListButtons()
        GetOpenPrescriptionsListButton.Enabled = False
        NextPageButton.Enabled = False
        PreviousPageButton.Enabled = False
        PutInProcessButton.Enabled = False
    End Sub

    Private Sub GetOpenPrescriptionsListView_CellContentClick(sender As Object, e As DataGridViewCellEventArgs) Handles GetOpenPrescriptionsListView.CellContentClick
        On Error GoTo ERR
        Dim colName As String = GetOpenPrescriptionsListView.Columns(e.ColumnIndex).Name
        If colName = "ViewColumn" Then
            Dim currentValue = GetOpenPrescriptionsListView.CurrentRow.Cells("RIDColumn").Value
            If ListOpenPrescriptionsResult.getPrescriptions IsNot Nothing Then
                For i = 0 To ListOpenPrescriptionsResult.getPrescriptions.size - 1
                    Dim item As be.recipe.services.executor.GetOpenPrescriptionForExecutor = ListOpenPrescriptionsResult.getPrescriptions.get(i)
                    If item.getRid = currentValue Then
                        PopupDialog.richTextBoxMessage.Text = Encoding.UTF8.GetString(item.getPrescription)
                        PopupDialog.richTextBoxMessage.Refresh()
                        PopupDialog.ShowDialog()
                    End If
                Next
            End If
        End If
        Exit Sub

ERR:
        showError(Err)
    End Sub

    Private Sub PutInProcessButton_Click(sender As Object, e As EventArgs) Handles PutInProcessButton.Click
        On Error GoTo ERR
        DisableGetOpenPrescriptionsListButtons()
        Dim Rids = GetCheckedRows(Me.GetOpenPrescriptionsListView, 6)
        If Rids.Count > 0 Then
            Dim value As String = String.Join(",", Rids)
            Dim param As be.recipe.services.executor.PutRidsInProcessParam = New be.recipe.services.executor.PutRidsInProcessParam
            Dim javaList As java.util.List = New java.util.ArrayList
            Dim str As String
            For Each str In Rids
                javaList.add(str)
            Next
            param.getRids().addAll(javaList)
            param.setMandateHolderId(ListOpenPrescriptionsMandateHolderTextBox.Text)

            Dim response As be.recipe.services.executor.PutRidsInProcessResult = GetRecipeModule().putData(param)
            If response.getStatus.getCode = 100 Then
                GetOpenPrescriptionsList()
            Else
                Dim errorList As java.util.List = response.getStatus.getMessages()
                If errorList IsNot Nothing Then
                    For i = 0 To errorList.size - 1
                        Dim localString As be.recipe.services.core.LocalisedString = errorList.get(i)
                        If localString.getLang().toString = "EN" Then
                            MessageBox.Show(localString.getValue())
                        End If
                    Next
                End If
            End If

        Else
            MessageBox.Show("No rows selected to put in process")
        End If
        EnableGetOpenPrescriptionsListButtons()
        Exit Sub
ERR:
        showError(Err)
        EnableGetOpenPrescriptionsListButtons()
    End Sub

    Function GetCheckedRows(grid As DataGridView, checkboxColumnIndex As Integer) As List(Of String)
        Dim checkedRows As New List(Of DataGridViewRow)
        Dim Rids As New List(Of String)
        For rowIndex As Integer = 0 To grid.RowCount - 1
            Dim chkCell = TryCast(grid(checkboxColumnIndex, rowIndex), DataGridViewCheckBoxCell)
            Dim isChecked As Boolean = CBool(chkCell.EditedFormattedValue)
            If isChecked Then
                checkedRows.Add(grid.Rows(rowIndex))
                Rids.Add(grid.Rows(rowIndex).Cells("RIDColumn").Value)
            End If

        Next
        Return Rids
    End Function

    Private Sub PreviousMonthButton_Click(sender As Object, e As EventArgs) Handles PreviousPageButton.Click
        On Error GoTo ERR
        listOpenPrescriptionsListPageNumber = listOpenPrescriptionsListPageNumber + 1
        If listOpenPrescriptionsListPageNumber = 0 Then
            NextPageButton.Enabled = False
        Else
            NextPageButton.Enabled = True
        End If
        GetOpenPrescriptionsList()
        Exit Sub
ERR:
        showError(Err)
        EnableGetOpenPrescriptionsListButtons()
    End Sub

    Private Sub NextMonthButton_Click(sender As Object, e As EventArgs) Handles NextPageButton.Click
        On Error GoTo ERR
        listOpenPrescriptionsListPageNumber = listOpenPrescriptionsListPageNumber - 1
        GetOpenPrescriptionsList()
        Exit Sub
ERR:
        showError(Err)
        EnableGetOpenPrescriptionsListButtons()
    End Sub

    Private Function translateReasonBreakTheGlass(text As String) As be.recipe.services.executor.ReasonBreakTheGlass
        On Error GoTo ERR
        Return be.recipe.services.executor.ReasonBreakTheGlass.valueOf(text)
ERR:
        Return Nothing
    End Function

    Function GetOpenPrescriptionsList() As be.recipe.services.executor.ListOpenPrescriptionsResult
        DisableGetOpenPrescriptionsListButtons()
        ListOpenPrescriptionsPageNumberLabel.Text = "Page: " & listOpenPrescriptionsListPageNumber
        Dim param As be.recipe.services.executor.ListOpenPrescriptionsParam = New be.recipe.services.executor.ListOpenPrescriptionsParam
        Dim Page As be.recipe.services.core.Page = New be.recipe.services.core.Page
        Dim bi As java.math.BigInteger
        bi = java.math.BigInteger.valueOf(listOpenPrescriptionsListPageNumber)
        Page.setPageNumber(bi)
        param.setPage(Page)
        param.setPatientId(ListOpenPrescriptionsPatientIdTextBox.Text)
        param.setMandateHolderId(ListOpenPrescriptionsMandateHolderTextBox.Text)

        If Not String.IsNullOrEmpty(ListOpenPrescriptionsBreakTheGlassComboBox.Text) Then
            Dim breakTheGlass As be.recipe.services.executor.BreakTheGlass = New be.recipe.services.executor.BreakTheGlass
            breakTheGlass.setReasonBreakTheGlass(translateReasonBreakTheGlass(ListOpenPrescriptionsBreakTheGlassComboBox.Text))
            breakTheGlass.setOtherReasonBreakTheGlass(ListOpenPrescriptionsBreakTheGlassTextBox.Text)
            param.setBreakTheGlass(breakTheGlass)
        End If

        ListOpenPrescriptionsResult = GetRecipeModule().getData(param)
        ListOpenPrescriptionsResult = GetRecipeModule().decryptListOpenPrescriptionsResult(ListOpenPrescriptionsResult)

        GetOpenPrescriptionsListView.Rows.Clear()
        If ListOpenPrescriptionsResult.getPrescriptions IsNot Nothing Then
            For i = 0 To ListOpenPrescriptionsResult.getPrescriptions.size - 1
                Dim item As be.recipe.services.executor.GetOpenPrescriptionForExecutor = ListOpenPrescriptionsResult.getPrescriptions.get(i)
                Dim pattern = "yyyy-MM-dd"
                Dim simpleDateFormat As java.text.SimpleDateFormat = New java.text.SimpleDateFormat(pattern)
                Dim expirationDate As java.util.Calendar = item.getExpirationDate
                Dim expirationDateString As String = ""
                If expirationDate IsNot Nothing Then
                    expirationDateString = simpleDateFormat.format(expirationDate.getTime())
                End If
                Dim status As String = item.getPrescriptionStatus.name

                GetOpenPrescriptionsListView.Rows.Add(item.getRid, item.getPrescriberId, simpleDateFormat.format(item.getCreationDate.getTime()), expirationDateString, status, item.getVision)

                If ListOpenPrescriptionsResult.getHasMoreResults.booleanValue Then
                    PreviousPageButton.Enabled = True
                Else
                    PreviousPageButton.Enabled = False
                End If

            Next
        End If

        EnableGetOpenPrescriptionsListButtons()
        Return ListOpenPrescriptionsResult
    End Function

    Private Sub listReservationsNextPageButton_Click(sender As Object, e As EventArgs) Handles ListReservationsNextPageButton.Click
        On Error GoTo ERR
        listReservationsListPageNumber = listReservationsListPageNumber - 1
        ListReservations()
        Exit Sub
ERR:
        showError(Err)
        EnableListReservationsButtons()
    End Sub

    Private Sub listReservationsPreviousPageButton_Click(sender As Object, e As EventArgs) Handles ListReservationsPreviousPageButton.Click
        On Error GoTo ERR
        listReservationsListPageNumber = listReservationsListPageNumber + 1
        ListReservations()
        Exit Sub
ERR:
        showError(Err)
        EnableListReservationsButtons()
    End Sub

    Private Sub GetReservationsButton_Click(sender As Object, e As EventArgs) Handles GetReservationsButton.Click
        On Error GoTo ERR
        ListReservations()
        Exit Sub
ERR:
        showError(Err)
        GetReservationsButton.Enabled = True
    End Sub

    Function ListReservations()
        ListReservationsDataGridView.Rows.Clear()
        DisableListReservationsButtons()
        ListReservationsPageNumberLabel.Text = "Page: " & listReservationsListPageNumber
        Dim param As be.recipe.services.executor.ListReservationsParam = New be.recipe.services.executor.ListReservationsParam
        Dim Page As be.recipe.services.core.Page = New be.recipe.services.core.Page
        Dim bi As java.math.BigInteger

        bi = java.math.BigInteger.valueOf(listReservationsListPageNumber)
        Page.setPageNumber(bi)
        param.setPage(Page)
        param.setMandateHolderId(ReservationsMandateHolderIdTextBox.Text)

        If Not DisableCalendarCheckbox.Checked Then
            Dim dateTime As String = SelectedListReservationsStartDateLabel.Text
            If String.IsNullOrEmpty(dateTime) Then
                Dim calendar1 As java.util.Calendar = java.util.Calendar.getInstance()
                Dim sdf1 As java.text.SimpleDateFormat = New java.text.SimpleDateFormat("dd/MM/yyyy")
                dateTime = sdf1.format(calendar1.getTime)
                SelectedListReservationsStartDateLabel.Text = dateTime
                Me.listReservationStartDate.Visible = False
            End If
            dateTime += " 00:00:00"
            Dim calendar As java.util.Calendar = java.util.Calendar.getInstance()

            Dim sdf As java.text.SimpleDateFormat = New java.text.SimpleDateFormat("dd/MM/yyyy hh:mm:ss")
            calendar.setTime(sdf.parse(dateTime))
            param.setStartDate(calendar)
        End If

        ListReservationsResult = GetRecipeModule().getData(param)
        ListReservationsResult = GetRecipeModule().decryptListReservationsResult(ListReservationsResult)

        ListReservationsDataGridView.Rows.Clear()

        If ListReservationsResult.getItems IsNot Nothing Then
            For i = 0 To ListReservationsResult.getItems.size - 1
                Dim item As be.recipe.services.executor.ListReservationsResultItem = ListReservationsResult.getItems.get(i)
                ListReservationsDataGridView.Rows.Add(item.getRid, item.getPrescriberId, item.getExecutorId, item.getPatientId,
              DateToString(item.getCreationDateReservation), DateToString(item.getLastUpdateReservation), DateToString(item.getCreationDate),
              DateToString(item.getExpirationDate), item.getPrescriptionStatus, item.getVision, item.getTelephoneNumber, item.getEmailAddress, item.getContactPreference)
            Next
        Else
            ListReservationsDataGridView.Rows.Clear()
        End If

        If ListReservationsResult.getHasMoreResults.booleanValue Then
            ListReservationsPreviousPageButton.Enabled = True
        Else
            ListReservationsPreviousPageButton.Enabled = False
        End If
        If listReservationsListPageNumber = 0 Then
            ListReservationsNextPageButton.Enabled = False
        Else
            ListReservationsNextPageButton.Enabled = True
        End If
        GetReservationsButton.Enabled = True

        Return ListReservationsResult
    End Function

    Private Sub EnableListReservationsButtons()
        GetReservationsButton.Enabled = True
        ListReservationsNextPageButton.Enabled = True
        ListReservationsPreviousPageButton.Enabled = True
    End Sub

    Private Sub DisableListReservationsButtons()
        GetReservationsButton.Enabled = False
        ListReservationsNextPageButton.Enabled = False
        ListReservationsPreviousPageButton.Enabled = False
    End Sub

    Private Function DateToString(dateValue As java.util.Calendar) As String
        Dim pattern = "yyyy-MM-dd"
        Dim simpleDateFormat As java.text.SimpleDateFormat = New java.text.SimpleDateFormat(pattern)
        If dateValue IsNot Nothing Then
            Return simpleDateFormat.format(dateValue.getTime)
        End If
        Return ""
    End Function
    Private Sub GetRidInProcessButton_Click(sender As Object, e As EventArgs) Handles GetRidInProcessButton.Click
        On Error GoTo ERR
        DisableGetRidInProcessButtons()
        GetRidInProcess()
        Exit Sub
ERR:
        showError(Err)
        EnableGetRidInProcessButtons()
    End Sub

    Private Sub GetRidInProcess()
        On Error GoTo ERR
        GetRidInProcessRichTextBox.Text = ""
        DisableGetRidInProcessButtons()
        Dim Page As be.recipe.services.core.Page = New be.recipe.services.core.Page
        ListRidsInProcessPageNumberLabel.Text = "Page: " & listRidsInProcessPageNumber
        Dim bi As java.math.BigInteger
        bi = java.math.BigInteger.valueOf(listRidsInProcessPageNumber)
        Page.setPageNumber(bi)

        Dim param As be.recipe.services.executor.ListRidsInProcessParam = New be.recipe.services.executor.ListRidsInProcessParam
        param.setPage(Page)
        param.setMandateHolderId(ListRidsInProcessMandateHolderIdTextBox.Text)

        Dim response As be.recipe.services.executor.ListRidsInProcessResult = GetRecipeModule().getData(param)

        If response.getRids IsNot Nothing Then
            For i = 0 To response.getRids.size - 1
                Dim item = response.getRids.get(i)
                GetRidInProcessRichTextBox.Text &= "" & item & vbCrLf
            Next
        Else
            GetRidInProcessRichTextBox.Text = ""
        End If
        If response.getHasMoreResults.booleanValue Then
            GetRidsInProcessPreviousButton.Enabled = True
        Else
            GetRidsInProcessPreviousButton.Enabled = False
        End If
        EnableGetRidInProcessButtons()
        Exit Sub
ERR:
        showError(Err)
        EnableGetRidInProcessButtons()
    End Sub

    Private Sub DisableGetRidInProcessButtons()
        GetRidInProcessButton.Enabled = False
        GetRidsInProcessPreviousButton.Enabled = False
        GetRidsInProcessNextButton.Enabled = False
    End Sub

    Private Sub EnableGetRidInProcessButtons()
        GetRidInProcessButton.Enabled = True
        If listRidsInProcessPageNumber = 0 Then
            GetRidsInProcessNextButton.Enabled = False
        Else
            GetRidsInProcessNextButton.Enabled = True
        End If
    End Sub

    Private Sub GetRidsInProcessPreviousButton_Click(sender As Object, e As EventArgs) Handles GetRidsInProcessPreviousButton.Click
        On Error GoTo ERR
        listRidsInProcessPageNumber = listRidsInProcessPageNumber + 1
        GetRidInProcess()
        Exit Sub
ERR:
        showError(Err)
        EnabledListRidsHistoryButtons()
    End Sub

    Private Sub GetRidsInProcessNextButton_Click(sender As Object, e As EventArgs) Handles GetRidsInProcessNextButton.Click
        On Error GoTo ERR
        listRidsInProcessPageNumber = listRidsInProcessPageNumber - 1
        GetRidInProcess()
        Exit Sub
ERR:
        showError(Err)
        EnabledListRidsHistoryButtons()
    End Sub

    Private Sub ListRidsHistoryButton_Click(sender As Object, e As EventArgs) Handles ListRidsHistoryButton.Click
        On Error GoTo ERR
        DisabledListRidsHistoryButtons()
        ListRidsHistory()
        EnabledListRidsHistoryButtons()
        Exit Sub
ERR:
        showError(Err)
        EnabledListRidsHistoryButtons()
    End Sub

    Private Sub DisabledListRidsHistoryButtons()
        ListRidsHistoryButton.Enabled = False
        ListRidsHistoryPreviousPageButton.Enabled = False
        ListRidsHistoryNextPageButton.Enabled = False
    End Sub

    Private Sub EnabledListRidsHistoryButtons()
        ListRidsHistoryButton.Enabled = True
        If ListRidsHistoryPageNumber = 0 Then
            ListRidsHistoryNextPageButton.Enabled = False
        Else
            ListRidsHistoryNextPageButton.Enabled = True
        End If
    End Sub





    Private Sub ListRidsHistory()
        ListRidsHistoryRichTextBox.Clear()
        DisabledListRidsHistoryButtons()
        Dim Page As be.recipe.services.core.Page = New be.recipe.services.core.Page
        ListRidsHistoryMonthLabel.Text = "Page: " & ListRidsHistoryPageNumber
        Dim bi As java.math.BigInteger
        bi = java.math.BigInteger.valueOf(ListRidsHistoryPageNumber)
        Page.setPageNumber(bi)

        Dim param As be.recipe.services.executor.ListRidsHistoryParam = New be.recipe.services.executor.ListRidsHistoryParam
        param.setPage(Page)
        param.setPatientId(ListRidsHistoryTextBox.Text)
        param.setMandateHolderId(ListRidsHistoryMandateHolderIdTextBox.Text)

        If ListRidsHistoryCheckBox.Checked Then
            param.setActiveResults(java.lang.Boolean.TRUE)
        Else
            param.setActiveResults(java.lang.Boolean.FALSE)
        End If

        If Not String.IsNullOrEmpty(ListRidsHistoryBreakTheGlassComboBox.Text) Then
            Dim breakTheGlass As be.recipe.services.executor.BreakTheGlass = New be.recipe.services.executor.BreakTheGlass
            breakTheGlass.setReasonBreakTheGlass(translateReasonBreakTheGlass(ListRidsHistoryBreakTheGlassComboBox.Text))
            breakTheGlass.setOtherReasonBreakTheGlass(ListRidsHistoryBreakTheGlassTextBox.Text)
            param.setBreakTheGlass(breakTheGlass)
        End If

        Dim ListRidsHistoryResult As be.recipe.services.executor.ListRidsHistoryResult = GetRecipeModule().getData(param)

        If ListRidsHistoryResult.getItems() IsNot Nothing Then
            For i = 0 To ListRidsHistoryResult.getItems().size - 1
                Dim item As be.recipe.services.executor.ListRidsHistoryResultItem = ListRidsHistoryResult.getItems().get(i)
                ListRidsHistoryRichTextBox.Text &= item.getRid & ": " & item.getPrescriptionStatus.name & ": " & item.getVision & vbCrLf
            Next
        Else
            ListRidsHistoryRichTextBox.Clear()
        End If
        If ListRidsHistoryResult.getHasMoreResults.booleanValue Then
            ListRidsHistoryPreviousPageButton.Enabled = True
        Else
            ListRidsHistoryPreviousPageButton.Enabled = False
        End If

        EnabledListRidsHistoryButtons()
    End Sub

    Private Function translateMandateHolderType(text As String) As be.recipe.services.core.MandateHolderType
        On Error GoTo ERR
        Return be.recipe.services.core.MandateHolderType.valueOf(text)
ERR:
        Return Nothing
    End Function

    Private Sub ListRidsHistoryPreviousMonthButton_Click(sender As Object, e As EventArgs) Handles ListRidsHistoryPreviousPageButton.Click
        On Error GoTo ERR
        ListRidsHistoryPageNumber = ListRidsHistoryPageNumber + 1
        ListRidsHistory()
        Exit Sub
ERR:
        showError(Err)
        EnabledListRidsHistoryButtons()
    End Sub

    Private Sub ListRidsHistoryNextMonthButton_Click(sender As Object, e As EventArgs) Handles ListRidsHistoryNextPageButton.Click
        On Error GoTo ERR
        ListRidsHistoryPageNumber = ListRidsHistoryPageNumber - 1
        ListRidsHistory()
        Exit Sub
ERR:
        showError(Err)
        EnabledListRidsHistoryButtons()
    End Sub

    Private Sub GetPrescriptionStatusButton_Click(sender As Object, e As EventArgs) Handles GetPrescriptionStatusButton.Click
        On Error GoTo ERR
        GetPrescriptionStatusButton.Enabled = False

        Dim param As be.recipe.services.executor.GetPrescriptionStatusParam = New be.recipe.services.executor.GetPrescriptionStatusParam
        param.setRid(GetPrescriptionRID.Text)
        param.setMandateHolderId(GetPrescriptionMandateHolderIdTextBox.Text)
        Dim result As be.recipe.services.executor.GetPrescriptionStatusResult = GetRecipeModule().getData(param)

        MessageBox.Show("PrescriptionStatus of prescription: " & GetPrescriptionRID.Text & " is: " & result.getPrescriptionStatus().name)

        GetPrescriptionStatusButton.Enabled = True
        Exit Sub
ERR:
        showError(Err)
        GetPrescriptionStatusButton.Enabled = True
    End Sub

    Private Sub txtSamlToken_TextChanged(sender As Object, e As EventArgs) Handles txtSamlToken.TextChanged

    End Sub

    Private Sub GetAndMarkAsDeliveredButton_Click(sender As Object, e As EventArgs) Handles GetAndMarkAsDeliveredButton.Click
        On Error GoTo ERR
        GetAndMarkAsDeliveredButton.Enabled = False
        GetprescriptionContent.Clear()
        GetPrescriptionPrescriber.Clear()
        GetPrescriptionPatient.Clear()
        GetprescriptionContent.Clear()

        Dim p As be.business.connector.recipe.executor.domain.GetPrescriptionForExecutorResult = GetRecipeModule().getAndMarkAsDelivered(GetPrescriptionRID.Text, GetPrescriptionMandateHolderIdTextBox.Text, translateMandateHolderType(GetPrescriptionMandateHolderTypeComboBox.Text))

        GetPrescriptionDate.Text = p.getCreationDate().getTime.toString
        GetPrescriptionPrescriber.Text = p.getPrescriberId()
        GetPrescriptionPatient.Text = p.getPatientId()
        GetprescriptionContent.Text = IOUtils.strConvert(p.getPrescription())

        Dim pattern = "yyyy-MM-dd"
        Dim simpleDateFormat As java.text.SimpleDateFormat = New java.text.SimpleDateFormat(pattern)
        Dim expirationDateString As String = ""
        If p.getExpirationDate IsNot Nothing Then
            expirationDateString = simpleDateFormat.format(p.getExpirationDate.getTime)
            ExpirationDateTextBox.Text = expirationDateString
        End If
        If (IsDBNull(p.getInsurabilityResponse())) Then
            MessageBox.Show("No Insurability!", "Information", MessageBoxButtons.OK, MessageBoxIcon.Information)
        Else
            txtInsurabilityOrchestration.Text = p.getInsurabilityResponse()
        End If
        feedbackCheckbox.Checked = p.isFeedbackAllowed().booleanValue

        CreateFeedbackRID.Text = GetPrescriptionRID.Text
        CreateFeedbackPrescriber.Text = p.getPrescriberId().ToString

        MessageBox.Show("GetAndMarkAsDelivered executed for prescription: " & p.getRid)

        GetAndMarkAsDeliveredButton.Enabled = True
        Exit Sub
ERR:
        showError(Err)
        GetAndMarkAsDeliveredButton.Enabled = True
    End Sub

    Private Sub ListMandatesButton_Click(sender As Object, e As EventArgs) Handles ListMandatesButton.Click
        On Error GoTo ERR
        ListMandates()
        Exit Sub
ERR:
        showError(Err)
        EnabledListMandatesButtons()
    End Sub

    Private Sub DisabledListMandatesButtons()
        On Error GoTo ERR
        ListMandatesButton.Enabled = False

        Exit Sub
ERR:
        showError(Err)
        EnabledListMandatesButtons()
    End Sub

    Private Sub EnabledListMandatesButtons()
        On Error GoTo ERR
        ListMandatesButton.Enabled = True
        Exit Sub
ERR:
        showError(Err)
        EnabledListMandatesButtons()
    End Sub

    Private Sub ListMandatesNextPageButton_Click(sender As Object, e As EventArgs)
        On Error GoTo ERR
        ListMandates()
        Exit Sub
ERR:
        showError(Err)
        EnabledListMandatesButtons()
    End Sub

    Private Sub ListMandatesPreviousPageButton_Click(sender As Object, e As EventArgs)
        On Error GoTo ERR
        ListMandates()
        Exit Sub
ERR:
        showError(Err)
        EnabledListMandatesButtons()
    End Sub

    Private Sub ListMandates()
        DisabledListMandatesButtons()
        Dim param As be.recipe.services.executor.ListRelationsParam = New be.recipe.services.executor.ListRelationsParam
        param.setMandateHolderId(MandateHolderIdTextBox.Text)
        ListRelationsResult = GetRecipeModule().getData(param)
        ListMandatesView.Rows.Clear()
        If ListRelationsResult.getItems IsNot Nothing Then
            For i = 0 To ListRelationsResult.getItems.size - 1
                Dim item As be.recipe.services.executor.ListRelationsItem = ListRelationsResult.getItems.get(i)
                ListMandatesView.Rows.Add(i, item.getMandateHolderId, item.getMandateHolderType.name, item.getPatientId, item.getPatientFirstname, item.getPatientLastname)
            Next
        End If

        EnabledListMandatesButtons()
    End Sub

    Private Sub ListReservationsDataGridView_CellContentClick(sender As Object, e As DataGridViewCellEventArgs) Handles ListReservationsDataGridView.CellContentClick
        On Error GoTo ERR
        Dim colName As String = ListReservationsDataGridView.Columns(e.ColumnIndex).Name
        If colName = "ViewReservationColumn" Then
            Dim currentValue = ListReservationsDataGridView.CurrentRow.Cells("ReservationsRIDColumn").Value
            If ListReservationsResult.getItems IsNot Nothing Then
                For i = 0 To ListReservationsResult.getItems.size - 1
                    Dim item As be.recipe.services.executor.ListReservationsResultItem = ListReservationsResult.getItems.get(i)
                    If item.getRid = currentValue Then
                        PopupDialog.richTextBoxMessage.Text = Encoding.UTF8.GetString(item.getPrescription.getPrescription)
                        PopupDialog.richTextBoxMessage.Refresh()
                        PopupDialog.ShowDialog()
                    End If
                Next
            End If
        End If
        Exit Sub

ERR:
        showError(Err)
    End Sub

    Private Sub ListManatesView_CellContentClick(sender As Object, e As DataGridViewCellEventArgs) Handles ListMandatesView.CellContentClick
        On Error GoTo ERR
        Dim colName As String = ListMandatesView.Columns(e.ColumnIndex).Name
        If colName = "SelectMandate" Then
            Dim currentValue = ListMandatesView.CurrentRow.Cells("RowId").Value
            Dim item As be.recipe.services.executor.ListRelationsItem = ListRelationsResult.getItems.get(currentValue)

            Me.GetPrescriptionMandateHolderIdTextBox.Text = item.getMandateHolderId
            Me.CreateFeedbackMandateHolderIdTextBox.Text = item.getMandateHolderId
            Me.ListNotificationMandateHolderIdTextBox.Text = item.getMandateHolderId
            Me.ListOpenPrescriptionsMandateHolderTextBox.Text = item.getMandateHolderId
            Me.ListRidsInProcessMandateHolderIdTextBox.Text = item.getMandateHolderId
            Me.ListRidsHistoryMandateHolderIdTextBox.Text = item.getMandateHolderId
            Me.ReservationsMandateHolderIdTextBox.Text = item.getMandateHolderId

            Me.GetPrescriptionMandateHolderTypeComboBox.SelectedItem = item.getMandateHolderType.name
            Me.CreateFeedbackMandateHolderTypeComboBox.SelectedItem = item.getMandateHolderType.name
            Me.ListNotificationMandateHolderTypeComboBox.SelectedItem = item.getMandateHolderType.name
            Me.ListOpenPrescriptionsMandateHolderTypeComboBox.SelectedItem = item.getMandateHolderType.name
            Me.ListRidsInProcessMandateHolderTypeComboBox.SelectedItem = item.getMandateHolderType.name
            Me.ListRidsHisotryMandateHolderTypeComboBox.SelectedItem = item.getMandateHolderType.name
            Me.ReservationsMandateHolderTypeComboBox.SelectedItem = item.getMandateHolderType.name

            Me.ListRidsHistoryTextBox.Text = item.getPatientId
            Me.ListOpenPrescriptionsPatientIdTextBox.Text = item.getPatientId

        End If
        Exit Sub

ERR:
        showError(Err)
    End Sub

    Private Sub ResetMandatesButton_Click(sender As Object, e As EventArgs) Handles ResetMandatesButton.Click
        Me.GetPrescriptionMandateHolderIdTextBox.Text = ""
        Me.CreateFeedbackMandateHolderIdTextBox.Text = ""
        Me.ListNotificationMandateHolderIdTextBox.Text = ""
        Me.ListOpenPrescriptionsMandateHolderTextBox.Text = ""
        Me.ListRidsInProcessMandateHolderIdTextBox.Text = ""
        Me.ListRidsHistoryMandateHolderIdTextBox.Text = ""
        Me.ReservationsMandateHolderIdTextBox.Text = ""
        ListMandatesView.Rows.Clear()
    End Sub

    Private Sub listReservationStartDate_DateChanged(sender As Object, e As DateRangeEventArgs) Handles listReservationStartDate.DateSelected
        Me.SelectedListReservationsStartDateLabel.Text = e.Start.ToShortDateString
        Me.SelectedListReservationsStartDateLabel.Visible = True
        Me.listReservationStartDate.Visible = False
    End Sub

    Sub SelectedListReservationsStartDateLabel_Click(sender As Object, e As EventArgs) Handles SelectedListReservationsStartDateLabel.Click
        Me.SelectedListReservationsStartDateLabel.Visible = False
        Me.listReservationStartDate.Visible = True
    End Sub

    Private Sub DisableCalendarCheckbox_CheckedChanged(sender As Object, e As EventArgs) Handles DisableCalendarCheckbox.CheckedChanged
        If DisableCalendarCheckbox.Checked Then
            listReservationStartDate.Enabled = False
            listReservationStartDate.Visible = False
            Me.SelectedListReservationsStartDateLabel.Text = ""
            Me.SelectedListReservationsStartDateLabel.Visible = False
        Else
            listReservationStartDate.Enabled = True
            listReservationStartDate.Visible = True
            Me.SelectedListReservationsStartDateLabel.Visible = True
        End If
    End Sub

    Private Sub ListReservationsPageNumberLabel_Click(sender As Object, e As EventArgs) Handles ListReservationsPageNumberLabel.Click

    End Sub

    Private Sub Label16_Click(sender As Object, e As EventArgs) Handles Label16.Click

    End Sub

    Private Sub TabPage2_Click(sender As Object, e As EventArgs) Handles TabPage2.Click

    End Sub

    Private Sub Label24_Click(sender As Object, e As EventArgs) Handles Label24.Click

    End Sub
End Class
