package be.business.connector.core.utils;

import org.w3c.dom.ls.LSInput;
import org.w3c.dom.ls.LSResourceResolver;

import java.io.InputStream;
import java.io.Reader;

import static java.nio.charset.StandardCharsets.UTF_8;

public class ClasspathLSResourceResolver implements LSResourceResolver {
    private final String location;

    public ClasspathLSResourceResolver(String location) {
        this.location = location;
    }


    @Override public LSInput resolveResource(String type, String namespaceURI, final String publicId, final String systemId, String baseURI) {
        return new LSInput() {
            @Override public Reader getCharacterStream() {
                return null;
            }

            @Override public void setCharacterStream(Reader characterStream) {

            }

            @Override public InputStream getByteStream() {
                return ClasspathLSResourceResolver.class.getResourceAsStream(location + systemId);
            }

            @Override public void setByteStream(InputStream byteStream) {

            }

            @Override public String getStringData() {
                return null;
            }

            @Override public void setStringData(String stringData) {

            }

            @Override public String getSystemId() {
                return systemId;
            }

            @Override public void setSystemId(String systemId) {

            }

            @Override public String getPublicId() {
                return publicId;
            }

            @Override public void setPublicId(String publicId) {

            }

            @Override public String getBaseURI() {
                return null;
            }

            @Override public void setBaseURI(String baseURI) {

            }

            @Override public String getEncoding() {
                return UTF_8.toString();
            }

            @Override public void setEncoding(String encoding) {

            }

            @Override public boolean getCertifiedText() {
                return false;
            }

            @Override public void setCertifiedText(boolean certifiedText) {

            }
        };
    }
}
