package be.recipe.api.executor;

import be.recipe.api.Prescription;

import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;

// tag::feature[]
public class FulfillReservation {
  @NotNull public Prescription.RID rid;

  @Size(max = 500)
  public String message;
  // end::feature[]

  public static FulfillReservation of(Prescription.RID rid) {
    return new FulfillReservation().rid(rid);
  }

  public static FulfillReservation of(Prescription.RID rid, String message) {
    return new FulfillReservation().rid(rid).message(message);
  }

  private FulfillReservation rid(Prescription.RID rid) {
    this.rid = rid;
    return this;
  }

  public FulfillReservation message(String message) {
    this.message = message;
    return this;
  }
  // tag::feature[]

  public interface Command<Request extends FulfillReservation> {
    void update(Request request);
  }
}
// end::feature[]
