package be.recipe.api.executor;

public interface PrescriptionService<
        Prescription extends be.recipe.api.Prescription,
        GetPrescription extends be.recipe.api.executor.GetPrescription,
        GetPrescriptionAndPutInProcess extends
            be.recipe.api.executor.GetPrescriptionAndPutInProcess,
        ListPrescriptions extends be.recipe.api.executor.ListPrescriptions,
        ListPrescriptionsResponse extends be.recipe.api.executor.ListPrescriptions.Response,
        UpdateProfile extends be.recipe.api.executor.UpdateProfile,
        GetProfile extends be.recipe.api.executor.GetProfile,
        GetProfileResponse extends be.recipe.api.executor.GetProfile.Response,
        ArchivePrescription extends be.recipe.api.executor.ArchivePrescription,
        GetPrescriptionStatus extends be.recipe.api.executor.GetPrescriptionStatus,
        GetPrescriptionStatusResponse extends be.recipe.api.GetPrescriptionStatusResponse>
    extends be.recipe.api.executor.GetPrescription.Command<GetPrescription, Prescription>,
        be.recipe.api.executor.GetPrescriptionAndPutInProcess.Command<
            GetPrescriptionAndPutInProcess, Prescription>,
        be.recipe.api.executor.ListPrescriptions.Command<
            ListPrescriptions, ListPrescriptionsResponse>,
        be.recipe.api.executor.UpdateProfile.Command<UpdateProfile>,
        be.recipe.api.executor.GetProfile.Command<GetProfile, GetProfileResponse>,
        be.recipe.api.executor.ArchivePrescription.Command<ArchivePrescription>,
        be.recipe.api.executor.GetPrescriptionStatus.Command<
                GetPrescriptionStatus, GetPrescriptionStatusResponse>{

  interface Simplified
      extends PrescriptionService<
          be.recipe.api.Prescription.Encrypted,
          be.recipe.api.executor.GetPrescription,
          be.recipe.api.executor.GetPrescriptionAndPutInProcess,
          be.recipe.api.executor.ListPrescriptions,
          be.recipe.api.executor.ListPrescriptions.Response.Encrypted,
          be.recipe.api.executor.UpdateProfile,
          be.recipe.api.executor.GetProfile,
          be.recipe.api.executor.GetProfile.Response,
          be.recipe.api.executor.ArchivePrescription,
          be.recipe.api.executor.GetPrescriptionStatus,
          be.recipe.api.GetPrescriptionStatusResponse> {}

  interface Ciphering<
          ListPrescriptions extends be.recipe.api.executor.ListPrescriptions,
          GetPrescription extends be.recipe.api.executor.GetPrescription,
          GetPrescriptionAndPutInProcess extends
              be.recipe.api.executor.GetPrescriptionAndPutInProcess,
          UpdateProfile extends be.recipe.api.executor.UpdateProfile,
          GetProfile extends be.recipe.api.executor.GetProfile,
          GetProfileResponse extends be.recipe.api.executor.GetProfile.Response,
          ArchivePrescription extends be.recipe.api.executor.ArchivePrescription>
      extends PrescriptionService<
          be.recipe.api.Prescription.PlainText,
          GetPrescription,
          GetPrescriptionAndPutInProcess,
          ListPrescriptions,
          be.recipe.api.executor.ListPrescriptions.Response.PlainText,
          UpdateProfile,
          GetProfile,
          GetProfileResponse,
          ArchivePrescription,
          be.recipe.api.executor.GetPrescriptionStatus,
          be.recipe.api.GetPrescriptionStatusResponse> {
    interface Simplified
        extends Ciphering<
            be.recipe.api.executor.ListPrescriptions,
            be.recipe.api.executor.GetPrescription,
            be.recipe.api.executor.GetPrescriptionAndPutInProcess,
            be.recipe.api.executor.UpdateProfile,
            be.recipe.api.executor.GetProfile,
            be.recipe.api.executor.GetProfile.Response,
            be.recipe.api.executor.ArchivePrescription> {}
  }
}
